package Irpg::Event;

use strict;
use warnings;
use Irpg::Utils qw(:text);
use Irpg::Irc qw(:interaction);
use Irpg::Action;
use Exporter qw(import);
our @EXPORT = qw(find_item evilchase);
our @EXPORT_OK = qw(hog);

my $opts;
my $rps;
=head1 FUNCTION init_pkg
    This function sets the references to
    options and players hashes.
=over
=item SCALAR (ref)    - reference to the options hash
=item SCALAR (ref)    - reference to the players hash
=cut
sub init_pkg { ($opts, $rps) = @_; }


sub find_item { # find item for argument player
    my $u = shift;
    my @items = ("ring","amulet","charm","weapon","helm","tunic",
                 "pair of gloves","set of leggings","shield","pair of boots");
    my $type = $items[rand(@items)];
    my $level = 1;
    my $ulevel;
    for my $num (1 .. int($rps->{$u}{level}*1.5)) {
        if (rand(1.4**($num/4)) < 1) {
            $level = $num;
        }
    }
    $level = $rps->{$u}{class}->real_lvl($level);
    if ($rps->{$u}{level} >= 25 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(50+int(rand(25)));
        $rps->{$u}{item}{helm} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Mattt's Omniscience Grand Crown! ".
                   "Your enemies fall before you as you anticipate their ".
                   "every move.",$rps->{$u}{nick});
            $rps->{$u}{item}{helm} = $ulevel."a";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 25 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(50+int(rand(25)));
        $rps->{$u}{item}{ring} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Juliet's Glorious Ring of ".
                   "Sparkliness! You enemies are blinded by both its glory ".
                   "and their greed as you bring desolation upon them.",
                   $rps->{$u}{nick});
            $rps->{$u}{item}{ring} = $ulevel."h";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 30 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(75+int(rand(25)));
        $rps->{$u}{item}{tunic} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Res0's Protectorate Plate Mail! ".
                   "Your enemies cower in fear as their attacks have no ".
                   "effect on you.",$rps->{$u}{nick});
            $rps->{$u}{item}{tunic} = $ulevel."b";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 35 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(100+int(rand(25)));
        $rps->{$u}{item}{amulet} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Dwyn's Storm Magic Amulet! Your ".
                   "enemies are swept away by an elemental fury before the ".
                   "war has even begun",$rps->{$u}{nick});
            $rps->{$u}{item}{amulet} = $ulevel."c";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 40 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(150+int(rand(25)));
        $rps->{$u}{item}{weapon} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Jotun's Fury Colossal Sword! Your ".
                   "enemies' hatred is brought to a quick end as you arc your ".
                   "wrist, dealing the crushing blow.",$rps->{$u}{nick});
            $rps->{$u}{item}{weapon} = $ulevel."d";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 45 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(175+int(rand(26)));
        $rps->{$u}{item}{weapon} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Drdink's Cane of Blind Rage! Your ".
                   "enemies are tossed aside as you blindly swing your arm ".
                   "around hitting stuff.",$rps->{$u}{nick});
            $rps->{$u}{item}{weapon} = $ulevel."e";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 48 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(250+int(rand(51)));
        $rps->{$u}{item}{"pair of boots"} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Mrquick's Magical Boots of ".
                   "Swiftness! Your enemies are left choking on your dust as ".
                   "you run from them very, very quickly.",$rps->{$u}{nick});
            $rps->{$u}{item}{"pair of boots"} = $ulevel."f";
            return;
        }
    }
    elsif ($rps->{$u}{level} >= 52 && rand(40) < 1) {
        $ulevel = $rps->{$u}{class}->real_lvl(300+int(rand(51)));
        $rps->{$u}{item}{weapon} =~ m/(\d+)\D?/;
        if ($ulevel >= $level && $ulevel > $1) {
            Irpg::Irc::notice("The light of the gods shines down upon you! You have ".
                   "found the level $ulevel Jeff's Cluehammer of Doom! Your ".
                   "enemies are left with a sudden and intense clarity of ".
                   "mind... even as you relieve them of it.",$rps->{$u}{nick});
            $rps->{$u}{item}{weapon} = $ulevel."g";
            return;
        }
    }
    my ($iteml,) = $rps->{$u}{item}{$type} =~ m/(\d+)\D?/;
    if ($level > $iteml) {
        Irpg::Irc::notice("You found a level $level $type! Your current $type is only ".
               "level ".$iteml.", so it seems Luck is with you!", $rps->{$u}{nick});
        $rps->{$u}{item}{$type} = $level;
    }
    else {
        Irpg::Irc::notice("You found a level $level $type. Your current $type is level ".
               $iteml.", so it seems Luck is against you. You toss the $type.",
               $rps->{$u}{nick});
    }
}


sub hog { # summon the hand of god
    #my @players = grep { $rps->{$_}{online} } keys(%$rps);
    #my $player = $players[rand(@players)];
    my $player = choose_player() || return;
    my $win = int(rand(5));
    my $time = int(((5 + int(rand(71)))/100) * $rps->{$player}{next});
    if ($win) {
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "Verily I say unto thee, the Heavens have burst forth, ".
                "and the blessed hand of God carried $player ".
                duration($time)." toward level ".($rps->{$player}{level}+1).
                "."));
        $rps->{$player}{next} += $rps->{$player}{class}->real_gain(-$time);
    }
    else {
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "Thereupon He stretched out His little finger among them ".
                "and consumed $player with fire, slowing the heathen ".
                duration($time)." from level ".($rps->{$player}{level}+1).
                "."));
        $rps->{$player}{next} += $rps->{$player}{class}->real_lvl($time);
    }
    Irpg::Irc::chanmsg("$player reaches next level in ".duration($rps->{$player}{next}).".");
}

sub choose_player {
    my @players = grep { $rps->{$_}{online} } keys(%$rps);
    return unless @players;

    #sort players by group of same levels
    my %levels = ();
    foreach (@players) {
        if (exists $levels{$rps->{$_}{level}}) {
            push $levels{$rps->{$_}{level}}, $_;
        }
        else {
            $levels{$rps->{$_}{level}} = [$_,];
        }
    }
    @players = @levels{sort keys %levels};

    #exponential distribution on levels (lambda = 0.5)
    my $rand_val = $#players+1;
    $rand_val = int(-log(rand) / 0.5) while ($rand_val > $#players);
    @players = @{$players[$rand_val]};
    #then uniform distribution for players of the same level
    return $players[rand(@players)];
}

sub calamity { # suffer a little one
    #my @players = grep { $rps->{$_}{online} } keys(%$rps);
    #return unless @players;
    #my $player = $players[rand(@players)];
    my $player = choose_player() || return;
    if (rand(10) < 1) {
        my @items = ("amulet","charm","weapon","tunic","set of leggings",
                     "shield");
        my $type = $items[rand(@items)];
        if ($type eq "amulet") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                    "$player fell, chipping the stone in his amulet! ".
                    "$player\'s $type loses 10% of its effectiveness."));
        }
        elsif ($type eq "charm") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                    "$player slipped and dropped his charm in a dirty ".
                    "bog! $player\'s $type loses 10% of its ".
                    "effectiveness."));
        }
        elsif ($type eq "weapon") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player left his weapon out in the rain to rust! ".
                "$player\'s $type loses 10% of its effectiveness."));
        }
        elsif ($type eq "tunic") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player spilled a level 7 shrinking potion on his ".
                "tunic! $player\'s $type loses 10% of its ".
                "effectiveness."));
        }
        elsif ($type eq "shield") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player\'s shield was damaged by a dragon's fiery ".
                "breath! $player\'s $type loses 10% of its ".
                "effectiveness."));
        }
        else {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player burned a hole through his leggings while ".
                "ironing them! $player\'s $type loses 10% of its ".
                "effectiveness."));
        }
        my ($val, $suffix) = ($rps->{$player}{item}{$type} =~ /(\d+)(\D?)$/);
        $rps->{$player}{item}{$type} = int($val * .9);
        $rps->{$player}{item}{$type}.=$suffix;
    }
    else {
        my $time = int(int(5 + rand(8)) / 100 * $rps->{$player}{next});
        $time = $rps->{$player}{class}->real_gain($time);
        if (!open(Q,$opts->{eventsfile})) {
            return Irpg::Irc::chanmsg("ERROR: Failed to open $opts->{eventsfile}: $!");
        }
        my($i,$actioned);
        while (my $line = <Q>) {
            chomp($line);
            if ($line =~ /^C (.*)/ && rand(++$i) < 1) { $actioned = $1; }
        }
        my $pron_obj = pronoun(3, $rps->{$player}{gender});
        my $pron_poss = pronoun(2, $rps->{$player}{gender});
        $actioned =~ s/<p_obj>/$pron_obj/g;
        $actioned =~ s/<p_poss>/$pron_poss/g;
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
            "$player $actioned. This terrible calamity has slowed ".
            $pron_obj." ".duration($time)." from level ".
            ($rps->{$player}{level}+1)."."));
        $rps->{$player}{next} += $time;
        Irpg::Irc::chanmsg("$player reaches next level in ".duration($rps->{$player}{next}).
                ".");
    }
}

sub godsend { # bless the unworthy
    #my @players = grep { $rps->{$_}{online} } keys(%$rps);
    #return unless @players;
    #my $player = $players[rand(@players)];
    my $player = choose_player() || return;
    if (rand(10) < 1) {
        my @items = ("amulet","charm","weapon","tunic","set of leggings",
                     "shield");
        my $type = $items[rand(@items)];
        if ($type eq "amulet") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player\'s amulet was blessed by a passing cleric! ".
                "$player\'s $type gains 10% effectiveness."));
        }
        elsif ($type eq "charm") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player\'s charm ate a bolt of lightning! ".
                "$player\'s $type gains 10% effectiveness."));
        }
        elsif ($type eq "weapon") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player sharpened the edge of his weapon! ".
                "$player\'s $type gains 10% effectiveness."));
        }
        elsif ($type eq "tunic") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "A magician cast a spell of Rigidity on $player\'s ".
                "tunic! $player\'s $type gains 10% effectiveness."));
        }
        elsif ($type eq "shield") {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$player reinforced his shield with a dragon's ".
                "scales! $player\'s $type gains 10% effectiveness."));
        }
        else {
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "The local wizard imbued $player\'s pants with a ".
                "Spirit of Fortitude! $player\'s $type gains 10% ".
                "effectiveness."));
        }
        my ($val, $suffix) = ($rps->{$player}{item}{$type} =~ /(\d+)(\D?)$/);
        $rps->{$player}{item}{$type} = int($val * 1.1);
        $rps->{$player}{item}{$type}.=$suffix;
    }
    else {
        my $time = int(int(5 + rand(8)) / 100 * $rps->{$player}{next});
        $time = -$rps->{$player}{class}->real_gain(-$time);
        if (!open(Q,$opts->{eventsfile})) {
            return Irpg::Irc::chanmsg("ERROR: Failed to open $opts->{eventsfile}: $!");
        }
        my($i,$actioned);
        while (my $line = <Q>) {
            chomp($line);
            if ($line =~ /^G (.*)/ && rand(++$i) < 1) { $actioned = $1; }
        }
        my $pron_obj = pronoun(3, $rps->{$player}{gender});
        my $pron_poss = pronoun(2, $rps->{$player}{gender});
        $actioned =~ s/<p_obj>/$pron_obj/g;
        $actioned =~ s/<g_poss>/$pron_poss/g;
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
            "$player $actioned! This wondrous godsend has ".
            "accelerated ".$pron_obj." ".duration($time).
            " towards level ".($rps->{$player}{level}+1)."."));
        $rps->{$player}{next} -= $time;
        Irpg::Irc::chanmsg("$player reaches next level in ".duration($rps->{$player}{next}).
                ".");
    }
}

sub evilness {
    my @evil = grep { $rps->{$_}{alignment} eq 'Evil' &&
                      $rps->{$_}{online} } keys(%$rps);
    return unless @evil;
    my $me = $evil[rand(@evil)];
    if (int(rand(2)) < 1) {
        # evil only steals from good :^(
        my @good = grep { $rps->{$_}{alignment} eq 'Good' &&
                          $rps->{$_}{online} } keys(%$rps);
        my $target = $good[rand(@good)];
        my @items = ("ring","amulet","charm","weapon","helm","tunic",
                     "pair of gloves","set of leggings","shield",
                     "pair of boots");
        my $type = $items[rand(@items)];
        my ($target_lvl,) = $rps->{$target}{item}{$type} =~ m/(\d+)\D?/;
        my ($me_lvl,) = $rps->{$me}{item}{$type} =~ m/(\d+)\D?/;
        if ($target_lvl > $me_lvl) {
            my $tempitem = $rps->{$me}{item}{$type};
            $rps->{$me}{item}{$type} = $rps->{$target}{item}{$type};
            $rps->{$target}{item}{$type} = $tempitem;
            Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$me stole $target\'s level $target_lvl $type while ".
                pronoun(1, $rps->{$target}{gender}).
                ($rps->{$target}{gender} eq 'n' ? " were " : " was ").
                "sleeping! $me leaves ".
                pronoun(2, $rps->{$me}{gender})." old level $me_lvl ".
                "$type behind, which $target then takes."));
        }
        else {
            Irpg::Irc::notice("You made to steal $target\'s $type, but realized it was ".
                   "lower level than your own. You creep back into the ".
                   "shadows.",$rps->{$me}{nick});
        }
    }
    else { # being evil only pays about half of the time...
        my $gain = 1 + int(rand(5));
        $gain = int(($gain/100)*$rps->{$me}{next});
        $gain = $rps->{$me}{class}->real_gain($gain);
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
            "$me is forsaken by ".pronoun(2, $rps->{$me}{gender}).
            " evil god. ".duration($gain)." is added to ".
            pronoun(2, $rps->{$me}{gender})." clock."));
        $rps->{$me}{next} += $gain;
        Irpg::Irc::chanmsg("$me reaches next level in ".duration($rps->{$me}{next}).".");
    }
}

sub evilchase {
    my ($player, $positions) = @_;
    return unless ($player && $positions);
    my ($x_pos, $y_pos) = ($rps->{$player}{x}, $rps->{$player}{y});
    my @opps = ();
    for (my $x = $x_pos-3; $x <= $x_pos+3; $x++) {
        for (my $y = $y_pos-3; $y <= $y_pos+3; $y++) {
            if (exists($positions->{$x}{$y}) &&
                $positions->{$x}{$y}{user} ne $player) {
                push @opps, $positions->{$x}{$y}{user};
            }
        }
    }
    return unless (@opps && rand(5) < 1);
    my $opp = $opps[int(rand(@opps))];
    Irpg::Irc::chanmsg(Irpg::Utils::clog(
        "$player, full of hatred and disdain for ".
        pronoun(2, $rps->{$player}{gender})." kind, has chased ".
        "after $opp who passed by."));
    collision_action($player, $opp);
}


sub goodness {
    my @players = grep { $rps->{$_}{alignment} eq 'Good' &&
                         $rps->{$_}{online} } keys(%$rps);
    return unless @players > 1;
    if (int(rand(2)) < 1) {
        splice(@players,int(rand(@players)),1) while @players > 2;
        my $gain = 5 + int(rand(8));
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$players[0] and $players[1] have not let the iniquities of ".
                "evil men poison them. Together have they prayed to their ".
                "God, and it is his light that now shines upon them. $gain\% ".
                "of their time is removed from their clocks."));
        $gain = int(($gain/100)*$rps->{$players[0]}{next});
        $rps->{$players[0]}{next} += int($rps->{$players[0]}{class}->real_gain(-$gain));
        $gain = int(($gain/100)*$rps->{$players[1]}{next});
        $rps->{$players[1]}{next} += int($rps->{$players[1]}{class}->real_gain(-$gain));
        Irpg::Irc::chanmsg("$players[0] reaches next level in ".
                duration($rps->{$players[0]}{next}).".");
        Irpg::Irc::chanmsg("$players[1] reaches next level in ".
                duration($rps->{$players[1]}{next}).".");
    }
    else {
        my $user = $players[int(rand(@players))];
        Irpg::Irc::chanmsg(Irpg::Utils::clog(
                "$user has been good to ".
                pronoun(2, $rps->{$user}{gender})." kind, and ".
                pronoun(2, $rps->{$user}{gender})." God has rewarded ".
                pronoun(3, $rps->{$user}{gender})." with a new piece of equipment"));
        find_item($user);
    }
}

sub rpcheck {
    my $rpreport = shift;
    my $online = shift;
    my $onlineevil = scalar(grep { $rps->{$_}{online} &&
                                   $rps->{$_}{alignment} eq 'Evil' } keys(%$rps));
    my $onlinegood = scalar(grep { $rps->{$_}{online} &&
                                   $rps->{$_}{alignment} eq 'Good' } keys(%$rps));
    if (!$opts->{noscale}) {
        if (rand((20*86400)/$opts->{self_clock}) < $online) { hog(); }
        if (rand((24*86400)/$opts->{self_clock}) < $online) { team_battle(); }
        if (rand((8*86400)/$opts->{self_clock}) < $online) { calamity(); }
        if (rand((4*86400)/$opts->{self_clock}) < $online) { godsend(); }
    }
    else {
        hog() if rand(4000) < 1;
        team_battle() if rand(4000) < 1;
        calamity() if rand(4000) < 1;
        godsend() if rand(2000) < 1;
    }
    if (rand((8*86400)/$opts->{self_clock}) < $onlineevil) { evilness(); }
    if (rand((12*86400)/$opts->{self_clock}) < $onlinegood) { goodness(); }
}


sub do_hog {
    my ($userhost, $usernick, $username, $source, @arg) = @_;
    Irpg::Irc::chanmsg("$usernick has summoned the Hand of God.");
    hog();
}


our $commands = {
    hog => {ref => \&do_hog, adm => 1, prv => 1, pub => 1,
            hlp => 'HOG : summon the Hand Of God spell.'}
};


1;
